// klikaczDlg.cpp : implementation file
//

#include "klikacz.h"
#include "klikaczDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CKlikaczDlg dialog

CKlikaczDlg::CKlikaczDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CKlikaczDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CKlikaczDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

void CKlikaczDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CKlikaczDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CKlikaczDlg, CDialog)
	//{{AFX_MSG_MAP(CKlikaczDlg)
	ON_WM_PAINT()
	ON_WM_TIMER()
	ON_BN_CLICKED(ID_O_GODZINIE, OnOGodzinie)
	ON_BN_CLICKED(ID_O_GODZINE_DBL, OnOGodzineDbl)
	ON_BN_CLICKED(ID_ZA_DBL, OnZaDbl)
	ON_BN_CLICKED(ID_ZA, OnZa)
	ON_BN_CLICKED(ID_STOP, OnStop)
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKlikaczDlg message handlers

BOOL CKlikaczDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	CWnd *c;
	c = GetDlgItem(IDC_ZA);
	c->SetWindowText("hh:mm:ss");
	c = GetDlgItem(IDC_O_GODZINIE);
	c->SetWindowText("hh:mm:ss");
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.


void CKlikaczDlg::add_time(SYSTEMTIME *s, uint hours, uint minutes, uint seconds)
{
	seconds = min(seconds, 60);
	minutes = min(minutes, 60);
	hours = min(hours, 24);

	s->wSecond += seconds;
	s->wMinute += minutes;
	s->wHour += hours;
	while (s->wSecond >= 60) {
		s->wSecond -= 60;
		++s->wMinute;
	}
	while (s->wMinute >= 60) {
		s->wMinute -= 60;
		++s->wHour;
	}
	while (s->wHour >= 24) {
		s->wHour -= 24;
		++s->wDay;
	}
}

uint CKlikaczDlg::convert_time(SYSTEMTIME &st)
{
	uint r(0);
	r += st.wDay * 24 * 3600;
	r += st.wHour * 3600;
	r += st.wMinute * 60;
	r += st.wSecond;

	return r;
}

bool CKlikaczDlg::check_time(uint st)
{
	if (st < activation_time)
		return false;

	return true;
}

void CKlikaczDlg::update_countdown()
{
	static char buffer[256];
	CWnd *c = GetDlgItem(IDC_COUNTDOWN);
	uint current_time;
	SYSTEMTIME st;

	GetLocalTime(&st);
	current_time = convert_time(st);
	sprintf(buffer, "%d seconds remain", activation_time - current_time);

	c->SetWindowText(buffer);
}

void CKlikaczDlg::OnTimer(UINT iTimer)
{
	uint current_time;
	SYSTEMTIME st;
	GetLocalTime(&st);
	current_time = convert_time(st);

func_begin:
	update_countdown();

	if (check_time(current_time)) {
		POINT p;
		GetCursorPos(&p);
		mouse_event(MOUSEEVENTF_LEFTDOWN, p.x, p.y, 0, 0);
		mouse_event(MOUSEEVENTF_LEFTUP, p.x, p.y, 0, 0);

		if (dblclick) {
			mouse_event(MOUSEEVENTF_LEFTDOWN, p.x, p.y, 0, 0);
			mouse_event(MOUSEEVENTF_LEFTUP, p.x, p.y, 0, 0);
		}
		check_multiple();
		if (!multiple_click)
			OnStop();
		else {
			activation_time += time_slot;
			goto func_begin;
		}
		clear_countdown();
	}
}

void CKlikaczDlg::clear_countdown()
{
	CWnd *c = GetDlgItem(IDC_COUNTDOWN);
	char buffer[1] = "";
	c->SetWindowText(buffer);
}

void CKlikaczDlg::OnPaint() 
{
	if (!IsIconic())
		CDialog::OnPaint();
}

void CKlikaczDlg::OnOGodzinie() 
{
	run_o_godzinie(false);
}

void CKlikaczDlg::OnOGodzineDbl() 
{
	run_o_godzinie(true);
}

void CKlikaczDlg::OnZaDbl() 
{
	run_za(true);
}

void CKlikaczDlg::OnZa() 
{
	run_za(false);
}

void CKlikaczDlg::run_za(bool dbl)
{
	SYSTEMTIME st;
	GetLocalTime(&st);
	uint seconds(0), minutes(0), hours(0);
	CWnd *c = GetDlgItem(IDC_ZA);
	CString s;
	c->GetWindowText(s);
	sscanf(s.GetBuffer(0), "%d:%d:%d", &hours, &minutes, &seconds);
	
	uint now = convert_time(st);
	add_time(&st, hours, minutes, seconds);
	activation_time = convert_time(st);
	time_slot = activation_time - now;

	if (hours || minutes || seconds)
		init_countdown(dbl);
}

void CKlikaczDlg::run_o_godzinie(bool dbl)
{
	SYSTEMTIME st;
	GetLocalTime(&st);
	CWnd *c = GetDlgItem(IDC_O_GODZINIE);
	CString s;
	uint now = convert_time(st);
	c->GetWindowText(s);
	st.wHour = 0;
	st.wMinute = 0;
	st.wSecond = 0;
	sscanf(s.GetBuffer(0), "%d:%d:%d", &st.wHour, &st.wMinute, &st.wSecond);

	activation_time = convert_time(st);
	time_slot = 86400;
	
	if (st.wHour || st.wMinute || st.wSecond)
		init_countdown(dbl);
}

void CKlikaczDlg::OnStop() 
{
	CWnd *hwnd;

	hwnd = GetDlgItem(ID_STOP);
	hwnd->EnableWindow(false);

	hwnd = GetDlgItem(ID_ZA);
	hwnd->EnableWindow(true);

	hwnd = GetDlgItem(ID_ZA_DBL);
	hwnd->EnableWindow(true);

	hwnd = GetDlgItem(ID_O_GODZINIE);
	hwnd->EnableWindow(true);

	hwnd = GetDlgItem(ID_O_GODZINE_DBL);
	hwnd->EnableWindow(true);

	KillTimer(1);
	clear_countdown();
}

void CKlikaczDlg::init_countdown(bool dbl)
{
	dblclick = dbl;
	SetTimer(1, 1000, 0);

	CWnd *hwnd;
	hwnd = GetDlgItem(ID_STOP);
	hwnd->EnableWindow(true);

	hwnd = GetDlgItem(ID_ZA);
	hwnd->EnableWindow(false);

	hwnd = GetDlgItem(ID_ZA_DBL);
	hwnd->EnableWindow(false);

	hwnd = GetDlgItem(ID_O_GODZINIE);
	hwnd->EnableWindow(false);

	hwnd = GetDlgItem(ID_O_GODZINE_DBL);
	hwnd->EnableWindow(false);
	
	update_countdown();
}

void CKlikaczDlg::check_multiple()
{
	CButton *c = (CButton *)GetDlgItem(IDC_CHECK);
	if (c->GetCheck() & BST_CHECKED)
		multiple_click = true;
	else 
		multiple_click = false;
}